Package org.python.core

# Class PyClass

java.lang.Object
org.python.core.PyObject
org.python.core.PyClass

All Implemented Interfaces:
  `Serializable`, `Traverseproc`

public class PyClass extends PyObject implements Traverseproc
The classic Python class.

See Also:
  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

## Field Summary

Fields
Modifier and Type
Field
Description
`PyTuple`
`__bases__`
The base classes of this class
`PyObject`
`__dict__`
Holds the namespace for this class
`String`
`__name__`
The name of this class
`static final PyType`
`TYPE`

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal`

## Method Summary

Modifier and Type
Method
Description
`PyObject`
`__call__(PyObject[] args, String[] keywords)`
The basic method to override when implementing a callable object.
`int`
`__cmp__(PyObject other)`
Equivalent to the standard Python __cmp__ method.
`void`
`__delattr__(String name)`
A variant of the __delattr__ method which accepts a String as the key.
`PyObject`
`__findattr_ex__(String name)`
Attribute lookup hook.
`void`
`__rawdir__(PyDictionary accum)`
`void`
`__setattr__(String name, PyObject value)`
A variant of the __setattr__ method which accepts a String as the key.
`PyString`
`__str__()`
Equivalent to the standard Python __str__ method.
`static PyObject`
`classobj___new__(PyNewWrapper new_, boolean init, PyType subtype, PyObject[] args, String[] keywords)`
`static PyObject`
`classobj___new__(PyObject name, PyObject bases, PyObject dict)`
`PyObject`
`fastGetDict()`
xxx implements where meaningful
`boolean`
`isCallable()`
`boolean`
`isSubClass(PyClass superclass)`
`void`
`noAttributeError(String name)`
Customized AttributeError for class objects.
`boolean`
`refersDirectlyTo(PyObject ob)`
Optional operation.
`void`
`setBases(PyObject value)`
`void`
`setDict(PyObject value)`
`void`
`setName(PyObject value)`
`String`
`toString()`
`int`
`traverse(Visitproc visit, Object arg)`
Traverses all directly contained `PyObject`s.

### Methods inherited from class org.python.core.PyObject

`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delete__, __delitem__, __delitem__, __delslice__, __delslice__, __dir__, __div__, __divmod__, __ensure_finalizer__, __eq__, __findattr__, __findattr__, __finditem__, __finditem__, __finditem__, __float__, __floordiv__, __format__, __ge__, __get__, __getattr__, __getattr__, __getitem__, __getitem__, __getnewargs__, __getslice__, __getslice__, __gt__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iter__, __iternext__, __itruediv__, __ixor__, __le__, __len__, __long__, __lshift__, __lt__, __mod__, __mul__, __ne__, __neg__, __nonzero__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setitem__, __setitem__, __setitem__, __setslice__, __setslice__, __sub__, __tojava__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, equals, fastGetClass, getDict, getType, hashCode, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isDataDescr, isIndex, isInteger, isMappingType, isNumberType, isSequenceType, object___subclasshook__, readonlyAttributeError, setType`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### TYPE

public static final PyType TYPE

### __dict__

public PyObject __dict__
Holds the namespace for this class

### __bases__

public PyTuple __bases__
The base classes of this class

### __name__

public String __name__
The name of this class

## Method Details

### classobj___new__

public static PyObject classobj___new__(PyNewWrapper new_, boolean init, PyType subtype, PyObject[] args, String[] keywords)

### classobj___new__

public static PyObject classobj___new__(PyObject name, PyObject bases, PyObject dict)

### fastGetDict

public PyObject fastGetDict()
Description copied from class: `PyObject`
xxx implements where meaningful

Overrides:
  `fastGetDict` in class `PyObject`
Returns:
  internal object per instance dict or null

### __findattr_ex__

public PyObject __findattr_ex__(String name)
Description copied from class: `PyObject`
Attribute lookup hook. If the attribute is not found, null may be returned or a Py.AttributeError can be thrown, whatever is more correct, efficient and/or convenient for the implementing class. Client code should use `PyObject.__getattr__(String)` or `PyObject.__findattr__(String)`. Both methods have a clear policy for failed lookups.

Overrides:
  `__findattr_ex__` in class `PyObject`
Returns:
  The looked up value. May return null if the attribute is not found

### __setattr__

public void __setattr__(String name, PyObject value)
Description copied from class: `PyObject`
A variant of the __setattr__ method which accepts a String as the key. This String must be interned.

Overrides:
  `__setattr__` in class `PyObject`
Parameters:
  `name` - the name whose value will be set - must be an interned string .
  `value` - the value to set this name to
See Also:
  - `PyObject.__setattr__(PyString, PyObject)`

### __delattr__

public void __delattr__(String name)
Description copied from class: `PyObject`
A variant of the __delattr__ method which accepts a String as the key. This String must be interned. By default, this will call `__delattr__(PyString name)` with the appropriate args. The only reason to override this method is for performance.

Overrides:
  `__delattr__` in class `PyObject`
Parameters:
  `name` - the name which will be removed - must be an interned string .
See Also:
  - `PyObject.__delattr__(PyString)`

### __rawdir__

public void __rawdir__(PyDictionary accum)

### noAttributeError

public void noAttributeError(String name)
Customized AttributeError for class objects.

Overrides:
  `noAttributeError` in class `PyObject`

### __call__

public PyObject __call__(PyObject[] args, String[] keywords)
Description copied from class: `PyObject`
The basic method to override when implementing a callable object. The first len(args)-len(keywords) members of args[] are plain arguments. The last len(keywords) arguments are the values of the keyword arguments.

Overrides:
  `__call__` in class `PyObject`
Parameters:
  `args` - all arguments to the function (including keyword arguments).
  `keywords` - the keywords used for all keyword arguments.

### isCallable

public boolean isCallable()

Overrides:
  `isCallable` in class `PyObject`

### __cmp__

public int __cmp__(PyObject other)
Description copied from class: `PyObject`
Equivalent to the standard Python __cmp__ method.

Overrides:
  `__cmp__` in class `PyObject`
Parameters:
  `other` - the object to compare this with.
Returns:
  -1 if `this<o`; 0 if `this==o`; +1 if `this>o`; -2 if no comparison is implemented

### __str__

public PyString __str__()
Description copied from class: `PyObject`
Equivalent to the standard Python __str__ method. The default implementation (in `PyObject`) calls `PyObject.__repr__()`, making it unnecessary to override `__str__` in sub-classes of `PyObject` where both forms are the same. A common choice is to provide the same implementation to `__str__` and `toString`, for consistency in the printed form of objects between Python and Java.

Overrides:
  `__str__` in class `PyObject`

### toString

public String toString()

Overrides:
  `toString` in class `PyObject`

### isSubClass

public boolean isSubClass(PyClass superclass)

### setDict

public void setDict(PyObject value)

Overrides:
  `setDict` in class `PyObject`

### setBases

public void setBases(PyObject value)

### setName

public void setName(PyObject value)

### traverse

public int traverse(Visitproc visit, Object arg)
Description copied from interface: `Traverseproc`
Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.

Specified by:
  `traverse` in interface `Traverseproc`

### refersDirectlyTo

public boolean refersDirectlyTo(PyObject ob)
Description copied from interface: `Traverseproc`
Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.

Specified by:
  `refersDirectlyTo` in interface `Traverseproc`